<?php
namespace App\Controllers\Tarifas;


use App\Controllers\BaseResourceController;

use App\Models\Collection;

use App\Entities\Tarifas\TarifaEncuadernacionLinea;

use App\Models\Tarifas\TarifaEncuadernacionLineaHorasModel;

use
DataTables\Editor,
DataTables\Database,
DataTables\Editor\Field,
DataTables\Editor\Format,
DataTables\Editor\Mjoin,
DataTables\Editor\Options,
DataTables\Editor\Upload,
DataTables\Editor\Validate,
DataTables\Editor\ValidateOptions;


class Tarifaencuadernacionlineashoras extends \App\Controllers\BaseResourceController
{

    protected $modelName = TarifaEncuadernacionLineaHorasModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Tarifa Encuadernacion Linea';
    protected static $singularObjectNameCc = 'tarifaEncuadernacionLinea';
    protected static $pluralObjectName = 'Tarifa Encuadernacion Lineas';
    protected static $pluralObjectNameCc = 'tarifaEncuadernacionLineas';

    protected static $controllerSlug = 'tarifaencuadernacionlineashoras';

    protected static $viewPath = 'themes/vuexy/form/tarifas/encuadernacion/';

    protected $indexRoute = 'tarifaEncuadernacionLineaHorasList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('TarifaEncuadernacionLineas.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;
        parent::initController($request, $response, $logger);

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('TarifaEncuadernacionLineas.tarifaencuadernacionLinea')]),
            'tarifaEncuadernacionLinea' => new TarifaEncuadernacionLinea(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewTarifaEncuadernacionLineaList', $viewData);
    }


    public function add()
    {


        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult):

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaEncuadernacionLinea'] = isset($sanitizedData) ? new TarifaEncuadernacionLinea($sanitizedData) : new TarifaEncuadernacionLinea();

        $this->viewData['formAction'] = route_to('createTarifaEncuadernacionLinea');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('TarifaEncuadernacionLineas.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()



    public function edit($requestedId = null)
    {

        if ($requestedId == null):
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $tarifaEncuadernacionLinea = $this->model->find($id);

        if ($tarifaEncuadernacionLinea == false):
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('TarifaEncuadernacionLineas.tarifaencuadernacionLinea')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;



        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('TarifaEncuadernacionLineas.tarifaencuadernacionLinea'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $tarifaEncuadernacionLinea->fill($sanitizedData);

                $thenRedirect = false;
            endif;
            if ($noException && $successfulResult):
                $id = $tarifaEncuadernacionLinea->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaEncuadernacionLinea'] = $tarifaEncuadernacionLinea;

        $this->viewData['formAction'] = route_to('updateTarifaEncuadernacionLinea', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('TarifaEncuadernacionLineas.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable_editor()
    {
        if ($this->request->isAJAX()) {

            include(APPPATH . "ThirdParty/DatatablesEditor/DataTables.php");

            // Build our Editor instance and process the data coming from _POST
            $response = Editor::inst($db, 'tarifa_encuadernacion_lineas_horas')
                ->fields(
                    Field::inst('tiempo_min')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.paginas_libro_min.decimal')
                            )
                        )
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('TarifaAcabadoLineas.validation.paginas_libro_min.required')
                            )
                        ),
                    Field::inst('tiempo_max')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.paginas_libro_max.decimal')
                            )
                        )
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('TarifaAcabadoLineas.validation.paginas_libro_max.required')
                            )
                        ),
                    Field::inst('precio_hora')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.precio_min.decimal')
                            )
                        )
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('TarifaAcabadoLineas.validation.precio_min.required')
                            )
                        ),
                    Field::inst('total_min')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifaEncuadernacionTiradas.validation.tirada_min.decimal')
                            )
                        )
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('TarifaEncuadernacionTiradas.validation.tirada_min.required')
                            )
                        ),
                    Field::inst('margen')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('TarifaAcabadoLineas.validation.margen.decimal')
                            )
                        )
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('TarifaAcabadoLineas.validation.margen.required')
                            )
                        ),
                    Field::inst('tirada_encuadernacion_id'),
                    Field::inst('user_created_id'),
                    Field::inst('created_at'),
                    Field::inst('user_updated_id'),
                    Field::inst('updated_at'),
                    Field::inst('is_deleted'),
                    Field::inst('deleted_at'),

                )
                ->validator(function ($editor, $action, $data) {
                    if ($action === Editor::ACTION_CREATE || $action === Editor::ACTION_EDIT) {
                        foreach ($data['data'] as $pkey => $values) {
                            // Si no se quiere borrar...
                            if ($data['data'][$pkey]['is_deleted'] != 1) {
                                $process_data['tiempo_min'] = $data['data'][$pkey]['tiempo_min'];
                                $process_data['tiempo_max'] = $data['data'][$pkey]['tiempo_max'];
                                $response = $this->model->checkIntervals($process_data, $pkey, $data['data'][$pkey]['tirada_encuadernacion_id']);
                                // No se pueden duplicar valores al crear o al editar
                                if (!empty($response)) {
                                    return $response;
                                }
                            }
                        }
                    }
                })
                ->on('preCreate', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_created_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('created_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->on('preEdit', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_updated_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('updated_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->debug(true)
                ->process($_POST)
                ->data();

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();

            $response[$csrfTokenName] = $newTokenHash;

            echo json_encode($response);

        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();

            $cleandatatable = $reqData['cleandatatable'] ?? 0;

            if ($cleandatatable) {

                $tarifa_encuadernacion_id = $reqData['tarifa_encuadernacion_id'] ?? -1;

                $datetime = (new \CodeIgniter\I18n\Time("now"));

                $this->model->removeAllEncuadernacionLineasHorasForTarifa($tarifa_encuadernacion_id, $datetime, 1);
                $newTokenHash = csrf_hash();
                $csrfTokenName = csrf_token();
                $data = [
                    $csrfTokenName => $newTokenHash
                ];
                return $this->respond($data);

            } else {
                if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                    $errstr = 'No data available in response to this specific request.';
                    $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                    return $response;
                }
                $start = $reqData['start'] ?? 0;
                $length = $reqData['length'] ?? 5;
                $search = $reqData['search']['value'];
                $requestedOrder = $reqData['order']['0']['column'] ?? 0;
                $order = TarifaEncuadernacionLineaHorasModel::SORTABLE[$requestedOrder >= 0 ? $requestedOrder : 0];
                $dir = $reqData['order']['0']['dir'] ?? 'asc';

                $id_TE = $reqData['tirada_id'] ?? -1;

                $resourceData = $this->model->getResource("", $id_TE)->orderBy($order, $dir)->limit($length, $start)->get()->getResultObject();

                return $this->respond(Collection::datatable(
                    $resourceData,
                    $this->model->getResource()->countAllResults(),
                    $this->model->getResource("", $id_TE)->countAllResults()
                ));
            }
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', tirada_encuadernacion_id', 'tirada_encuadernacion_id', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->tirada_encuadernacion_id = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'tirada_encuadernacion_id'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

}
